"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.Map = void 0;
const red_black_tree_1 = require("./red-black-tree");
const base_collection_1 = require("./base-collection");
class Map extends base_collection_1.BaseCollection {
    rbTree;
    constructor(comparator = (a, b) => a < b) {
        super();
        this.rbTree = new red_black_tree_1.RedBlackTree(comparator);
    }
    insert(key, value) {
        this.rbTree.insert(key, value);
    }
    find(key) {
        return this.rbTree.find(key);
    }
    delete(key) {
        this.rbTree.remove(key);
    }
    remove(key) {
        this.rbTree.remove(key);
    }
    clear() {
        this.rbTree.clear();
    }
    size() {
        return this.rbTree.size();
    }
    isEmpty() {
        return this.rbTree.isEmpty();
    }
    forEach(callback) {
        this.rbTree.forEach(callback);
    }
    equals(other) {
        if (!other || !(other instanceof Map))
            return false;
        return this.rbTree.equals(other.rbTree);
    }
}
exports.Map = Map;
//# sourceMappingURL=map.js.map